#usage: python auto.py n1 n2 n3 min.txt prod.txt
# Finds the maxslope of the loglog curve and plots the scores in decreasing order and logscalses for each file n1, n2...

import numpy as np
import sys
import matplotlib.pyplot as plt



#find the highest slope in log-log:

#steps to compute de derivative:
nx=900
ny=30

#Range to explore:
MIN=1 #10**MIN
MAX=4	#10**MAX

def autocom(S):
	x=np.zeros(nx)
	y=np.zeros(nx)
	z=np.zeros(nx,dtype=int)
	for i in range(nx):
		z[i]=int(10**(MIN+(MAX-MIN)*i/(nx-1.)))
		y[i]=np.log10(S[z[i]])
		x[i]=np.log10(float(z[i]))
	p=np.zeros(nx-2*ny)
	for i in range(nx-2*ny):
		p[i]=(y[i+2*ny]-y[i])/(x[i+2*ny]-x[i])
	argpmin=np.argmin(p)+ny
	pmin=p[argpmin]
	return [pmin,z[argpmin]]



for f in sys.argv[1:]:
	S=sorted(np.loadtxt(f,usecols=[1]),reverse=True)
	pmin,zmin=autocom(S)
	plt.loglog(S,'-',[zmin,zmin],[S[10**MIN],S[10**MAX]],'k-')
	print "maxslope at rank:",zmin
	plt.hold(True)
#plt.xlim([1,len(S)/4])
plt.ylabel('SCORE')
plt.xlabel('RANK OF NODE ACCORDING TO SCORE')
plt.savefig("plot.png")
plt.show()
		
